unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  TAGraph, TAIntervalSources, TASeries;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    DateTimeIntervalChartSource1: TDateTimeIntervalChartSource;
    Panel1: TPanel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure DateTimeIntervalChartSource1DateTimeStepChange(Sender: TObject;
      ASteps: TDateTimeStep);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    FStartTime: TDateTime;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  TAChartUtils;

const
  ONE_MINUTE = 1.0 / (24 * 60);

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if not Timer1.Enabled then
  begin
    Chart1.BottomAxis.Visible := true;
    FStartTime := Now;
    Timer1.Enabled := true;
  end;
end;

procedure TForm1.DateTimeIntervalChartSource1DateTimeStepChange(
  Sender: TObject; ASteps: TDateTimeStep);
var
  s: String;
begin
  case ASteps of
    dtsHour: s := ' (Std:Min)';
    dtsMinute: s := ' (Std:Min:Sec)';
    dtsSecond: s := ' (Min:Sec)';
    dtsMillisecond: s := ' (ms)';
  end;
  Chart1.BottomAxis.Title.Caption := 'Verstrichene Zeit' + s;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Das folgende kann man auch im Objekt-Inspektor einstellen. Ich bringe es
  // hier nur zur Verdeutlichung
  Chart1.BottomAxis.Marks.Source := DateTimeIntervalChartSource1;
  Chart1.BottomAxis.Marks.Style := smsLabel;  // benötigt unit TAChartUtils
  Chart1.BottomAxis.Title.Visible := true;
  Chart1.BottomAxis.Visible := false;
  // Abstand zwischen den Achsenmarkierungen vergrößern, zur Vermeidung von Überlappung
  DateTimeIntervalChartSource1.Params.MaxLength := 120;
  // Übergeordnete Einheit immer anzeigen
  DateTimeIntervalChartSource1.SuppressPrevUnit := false;
  // Besseres Anzeigeformat
  DateTimeIntervalChartSource1.DateTimeStepFormat.MinuteFormat := 'h:mm:ss';
  DateTimeIntervalChartSource1.DateTimeStepFormat.HourFormat := '[h]:mm';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const
  PERIODE = 10*ONE_MINUTE;
var
  t: TDateTime;
  y: Double;
begin
  t := (Now - FStartTime)*100;  // 100-fache Beschleunigung
  // Verrauschtes sinus-Signal.
  y := sin(2*pi*t/PERIODE) + (random-0.5) * 0.1;
  Chart1LineSeries1.AddXY(t, y);
end;

end.

